/**********************************************************************
 *
 * pagedbrowserclass.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * 
 *
 *********************************************************************/


#include "cstrpagedbrowserclass.h"
#include <assert.h>
#include "OIDtools.h"

cstrpagedbrowserclass::cstrpagedbrowserclass () {
}

cstrpagedbrowserclass::~cstrpagedbrowserclass () {
}


int cstrpagedbrowserclass::output_section_group (FilterResponse_t &sections, cgiargsclass &args,
					     const text_t &/*collection*/, int /*colnumber*/, 
					     format_t * /*formatlistptr*/, bool /*use_table*/, 
					     text_tset &/*metadata*/, bool &/*getParents*/,
					     recptproto * /*collectproto*/, displayclass &disp, 
					     outconvertclass &outconvert, ostream &textout, 
					     ostream &/*logout*/) {

  text_t &arg_d = args["d"];

  // this browser class only handles document levels
  if (arg_d.empty()) return 0;

  // dont want page nums and arrows if text is expanded
  if (!args.getintarg("gt")) {
    text_t previousOID, previoustitle, nextOID, nexttitle;
    text_t previousarrow, nextarrow;
    bool found = false;
    
    text_t pagenum;
    // this should be our list of pages
    
    ResultDocInfo_tarray::iterator thissection = sections.docInfo.begin();
    ResultDocInfo_tarray::iterator endsection = sections.docInfo.end();
    
    while (thissection != endsection) {
      if (arg_d == (*thissection).OID) {
	found = true;
	pagenum= "<td><center><b>_document:page_" +
	  (*thissection).metadata["Title"].values[0] + "\n";
	if (thissection != sections.docInfo.begin()) {
	  previousOID = (*(thissection-1)).OID;
	  previoustitle = (*(thissection-1)).metadata["Title"].values[0];
	} else 
	  previousarrow = "_document:parentarrow_";
	
	if (thissection != sections.docInfo.end()) {
	  nextOID = (*(thissection+1)).OID;
	  nexttitle = (*(thissection+1)).metadata["Title"].values[0];
	}
	break;
      }
      thissection ++;
    }

    int numpages = sections.docInfo.size();
    //pagenum += "_document:textnumpages_(" + text_t(numpages) + ")</center></td>\n";
    pagenum += "_document:of_" + text_t(numpages) + "</b></center></td>\n";
    if (!found)
      nextarrow = "<a href=\"_httpdocument_&cl=" + args["cl"] + "&d=" + sections.docInfo[0].OID + 
	"\">" + sections.docInfo[0].metadata["Title"].values[0] + "_iconnext_</a>\n";
    else {
      if (!previousOID.empty())
	previousarrow = "<a href=\"_httpdocument_&cl=" + args["cl"] + "&d=" + 
	  previousOID + "\">_iconprev_</a>\n";
      if (!nextOID.empty())
	nextarrow = "<a href=\"_httpdocument_&cl=" + args["cl"] + "&d=" + 
	  nextOID + "\">_iconnext_</a>\n";
    }
  
    textout << outconvert << disp << "<table><tr valign=top>"
	    << " <td align=right>" << previousarrow << "</td>\n"
	    << "<td align=center>" << pagenum << "</td>\n"
	    << "<td align=left>" << nextarrow << "</td></tr>\n"
            << "<tr valign=middle>\n"
            << "<td align=center valign=top colspan=3>_document:gotoform_</td>"
	    << "</tr></table>\n";
  }
  else { // just output goto form
    textout << outconvert << disp << "<center>_document:gotoform_ </center>";
  }
  return 0;
}



